#ifndef KEYFRAMEANIMHEADER
#define KEYFRAMEANIMHEADER


#include <Quaternion.h>
#include <Matrix4x4.h>
#include <Vector3.h>
#include <Common.h>
#include <Pose.h>

#include <set>
#include <vector>
#include <map>
#include <string>
#include <Track.h>

class KeyFrameAnim
{

	std::vector<QTrack> tracks; //the rotational data for the joints
	
	STrack height; //the y translation of the root joint
	VTrack position; // the XZ translation of the root joint
	QTrack heading; // the Y rotation of the root joint	
	STrack head;
	
	Vector3 translation;

	Pose currentPose;
	float currentTime; //the current time

	float maxtime; //the max time in the database
	
	static std::map<std::string, KeyFrameAnim> anims;

	bool LoadFromFile(const char * fname);

	std::string fname;
	unsigned int numJoints;

public:
	
	static bool Load(const char * name, const char * fname);
	static void Unload(const char * name);
	static KeyFrameAnim * GetPtr(const char * name);


	KeyFrameAnim();
	~KeyFrameAnim();
	void SetTime(const float time);
	unsigned int GetNumJoints() const;
	float GetDuration();
	Pose GetPose();

	void GetTranslation(Vector3 & v);

};

#endif