#ifndef SCENEHEADER
#define SCENEHEADER
#include "InputEvent.h"
#include "TimeStamp.h"
#include <set>

class Scene 
{
protected:
	unsigned int windowX, windowY;
public:
	Scene();
	~Scene();

	void AddInputEvent(InputEvent & event);
	virtual bool Initialize() =0;
	virtual void RenderPersp() =0;
	virtual void RenderOrtho() =0;
	virtual void Update() = 0;
	void SetWindowSize(const unsigned int xsize, const unsigned int ysize);

protected:
	std::set<InputEvent> events;
};


#endif 
