#include "BehaviorRoutines.h"
#include "Agent.h"

BehaviorRoutines::BehaviorRoutines()
{
	agent = NULL;
}

BehaviorRoutines::~BehaviorRoutines()
{
}

void
BehaviorRoutines::SetAgent(Agent * a)
{
	agent = a;
}

bool
BehaviorRoutines::PlayIntention(Intention intention)
{
	std::string action;
	int r;

	agent->GetPerception()->OpponentDistance();
	agent->GetPerception()->OpponentAngle();

	r = rand() % 100;
	if (agent->GetState()->GetEnergy() < r)
		agent->GetActor()->SetAttribute("small", 1);
	else
		agent->GetActor()->SetAttribute("small", 0);

	r = rand() % 100;
	if (agent->GetState()->GetEnergy() < r)
		agent->GetActor()->SetAttribute("big", 0);
	else
		agent->GetActor()->SetAttribute("big", 1);

	switch (intention)
	{
	case FACE:
		action = FaceOpponent();
		break;
	case RECOVER:
		action = Recover();
		break;
	case APPROACH:
		action = ApproachOpponent();
		break;
	case EVADE:
		action = Evade();
		break;
	case ATTACK:
		action = Attack();
		break;
	case DEFEND:
		action = Defend();
		break;
	case ESCAPE_ROPES:
		action = EscapeRopes();
		break;
	default:
		return false;
	}

	return agent->PlayAction(action.c_str());
}

std::string
BehaviorRoutines::FaceOpponent()
{
	std::string action;
	float opangle;

	// Choose direction
	opangle = agent->GetPerception()->GetLastAngle();
	if (opangle > 0)
		action = "turn_left";
	else
		action = "turn_right";

	// Choose amount to turn
	if (opangle > 30 || opangle < -30)
	{
		agent->GetActor()->SetAttribute("small", 0);
		agent->GetActor()->SetAttribute("big", 1);
	}
	else
	{
		agent->GetActor()->SetAttribute("small", 1);
		agent->GetActor()->SetAttribute("big", 0);
	}

	return action;
}

std::string
BehaviorRoutines::Recover()
{
	std::string action;
	float opdist;

	opdist = agent->GetPerception()->GetLastDistance();
	if (opdist < 2)
	{
		if (opdist < 1)
		{
			agent->GetActor()->SetAttribute("small", 0);
			agent->GetActor()->SetAttribute("big", 1);
		}
		else
		{
			agent->GetActor()->SetAttribute("small", 1);
			agent->GetActor()->SetAttribute("big", 0);
		}
		float opangle = agent->GetPerception()->GetLastAngle();
		if (opangle < 180 && opangle > -180)
			action = "step_back";
		else
			action = "step_forward";
	}
	else
	{
		action = "recover";
	}

	return action;
}

std::string
BehaviorRoutines::ApproachOpponent()
{
	std::string action;
	float opdist;

	opdist = agent->GetPerception()->GetLastDistance();
	if (opdist < 2)
	{
		agent->GetActor()->SetAttribute("small", 1);
		agent->GetActor()->SetAttribute("big", 0);
	}
	else
	{
		agent->GetActor()->SetAttribute("small", 0);
		agent->GetActor()->SetAttribute("big", 1);
	}
	action = "step_forward";

	return action;
}

std::string
BehaviorRoutines::Evade()
{
	std::string action;
	int r;

	r = rand() % 100;
	if (r < 20)
		action = "dodge_left";
	else if (r < 40)
		action = "dodge_right";
	else if (r < 60)
		action = "dodge_back";
	else if (r < 80)
		action = "dodge_down";
	else
		action = "block";

	return action;
}

std::string
BehaviorRoutines::Attack()
{
	std::string action;
	int r;

	r = rand() % 100;

	if (r < 60)
		action = "jab";
	else if (r < 85)
		action = "cross";
	else
		action = "hook";

	if (agent->GetPerception()->GetLastDistance() < 1 && r < 15)
		action = "upper_cut";

	return action;
}

std::string
BehaviorRoutines::Defend()
{
	std::string action;
	int r;
	float opdist;

	r = rand() % 100;
	opdist = agent->GetPerception()->GetLastDistance();
	if (opdist > 2)
	{
		if (r < 60)
			action = "hold_glove";
		else
			action = "block";
	}
	else
	{
		if (r < 40)
			action = "block";
		else if (r < 60)
			action = "feint";
		else if (r < 80)
			action = "step_back";
		else if (r < 90)
			action = "step_left";
		else
			action = "step_right";
	}

	return action;
}

std::string
BehaviorRoutines::EscapeRopes()
{
	std::string action;
	int r;

	r = rand() % 100;

	if (r < 40)
		action = "step_left";
	else if (r < 80)
		action = "step_right";
	else
		action = "step_forward";

	return action;
}