#include "State.h"
#include "Agent.h"

#define round(x) ((int) (x + 0.5f))

State::State()
{
	style = skill = strength = 0;
	energy = 1;
}

State::~State()
{
}

void
State::SetAgent(Agent * a)
{
	agent = a;
}

void
State::SetStrength(float str)
{
	strength = str;
}

float
State::FinishAction(ActionTerminator at)
{
	// Penalize energy unless a hit or recovery was made
	if (at == HIT)
	{
		energy += 0.025f;
		if (energy > 1)
			energy = 1;
	}
	else if (at == OP_HIT)
	{
		energy *= 0.95f;
	}
	else
	{
		if (agent->GetAction() == "recover")
		{
			energy += 0.05f;
			if (energy > 1)
				energy = 1;
		}
		else if (agent->GetAction() == "jab")
		{
			energy *= 0.98f;
		}
		else if (agent->GetAction() == "cross" ||
		         agent->GetAction() == "hook" ||
		         agent->GetAction() == "upper_cut")
		{
			energy *= 0.97f;
		}
		else
		{
			energy *= 0.99f;
		}
	}

	// Set motion attributes to match state
	agent->GetActor()->SetAttribute("energetic", (float) round(energy));
	agent->GetActor()->SetAttribute("tired", (float) round(1 - energy));

	return 1;
}

float
State::GetEnergy() {
	return energy;
}