#include <stdlib.h>
#include <memory.h>
#include <math.h>

//multiplies two matrix4x4s together. M1*M2 = Result
void MultMatrix(float * m1,float * m2, float * result)
{
    result[ 0] = m1[ 0] * m2[ 0] + m1[ 1] * m2[ 4] + m1[ 2] * m2[ 8] + m1[ 3] * m2[12];
    result[ 1] = m1[ 0] * m2[ 1] + m1[ 1] * m2[ 5] + m1[ 2] * m2[ 9] + m1[ 3] * m2[13];
    result[ 2] = m1[ 0] * m2[ 2] + m1[ 1] * m2[ 6] + m1[ 2] * m2[10] + m1[ 3] * m2[14];
    result[ 3] = m1[ 0] * m2[ 3] + m1[ 1] * m2[ 7] + m1[ 2] * m2[11] + m1[ 3] * m2[15];

    result[ 4] = m1[ 4] * m2[ 0] + m1[ 5] * m2[ 4] + m1[ 6] * m2[ 8] + m1[ 7] * m2[12];
    result[ 5] = m1[ 4] * m2[ 1] + m1[ 5] * m2[ 5] + m1[ 6] * m2[ 9] + m1[ 7] * m2[13];
    result[ 6] = m1[ 4] * m2[ 2] + m1[ 5] * m2[ 6] + m1[ 6] * m2[10] + m1[ 7] * m2[14];
    result[ 7] = m1[ 4] * m2[ 3] + m1[ 5] * m2[ 7] + m1[ 6] * m2[11] + m1[ 7] * m2[15];

    result[ 8] = m1[ 8] * m2[ 0] + m1[ 9] * m2[ 4] + m1[10] * m2[ 8] + m1[11] * m2[12];
    result[ 9] = m1[ 8] * m2[ 1] + m1[ 9] * m2[ 5] + m1[10] * m2[ 9] + m1[11] * m2[13];
    result[10] = m1[ 8] * m2[ 2] + m1[ 9] * m2[ 6] + m1[10] * m2[10] + m1[11] * m2[14];
    result[11] = m1[ 8] * m2[ 3] + m1[ 9] * m2[ 7] + m1[10] * m2[11] + m1[11] * m2[15];

    result[12] = m1[12] * m2[ 0] + m1[13] * m2[ 4] + m1[14] * m2[ 8] + m1[15] * m2[12];
    result[13] = m1[12] * m2[ 1] + m1[13] * m2[ 5] + m1[14] * m2[ 9] + m1[15] * m2[13];
    result[14] = m1[12] * m2[ 2] + m1[13] * m2[ 6] + m1[14] * m2[10] + m1[15] * m2[14];
    result[15] = m1[12] * m2[ 3] + m1[13] * m2[ 7] + m1[14] * m2[11] + m1[15] * m2[15];
}

//multiplies two matrix4x4s together. M1*M2 -> overwrites m1
void MultMatrixPost(float * m1,const float * m2)
{
	float result[16];
    result[ 0] = m1[ 0] * m2[ 0] + m1[ 1] * m2[ 4] + m1[ 2] * m2[ 8] + m1[ 3] * m2[12];
    result[ 1] = m1[ 0] * m2[ 1] + m1[ 1] * m2[ 5] + m1[ 2] * m2[ 9] + m1[ 3] * m2[13];
    result[ 2] = m1[ 0] * m2[ 2] + m1[ 1] * m2[ 6] + m1[ 2] * m2[10] + m1[ 3] * m2[14];
    result[ 3] = m1[ 0] * m2[ 3] + m1[ 1] * m2[ 7] + m1[ 2] * m2[11] + m1[ 3] * m2[15];

    result[ 4] = m1[ 4] * m2[ 0] + m1[ 5] * m2[ 4] + m1[ 6] * m2[ 8] + m1[ 7] * m2[12];
    result[ 5] = m1[ 4] * m2[ 1] + m1[ 5] * m2[ 5] + m1[ 6] * m2[ 9] + m1[ 7] * m2[13];
    result[ 6] = m1[ 4] * m2[ 2] + m1[ 5] * m2[ 6] + m1[ 6] * m2[10] + m1[ 7] * m2[14];
    result[ 7] = m1[ 4] * m2[ 3] + m1[ 5] * m2[ 7] + m1[ 6] * m2[11] + m1[ 7] * m2[15];

    result[ 8] = m1[ 8] * m2[ 0] + m1[ 9] * m2[ 4] + m1[10] * m2[ 8] + m1[11] * m2[12];
    result[ 9] = m1[ 8] * m2[ 1] + m1[ 9] * m2[ 5] + m1[10] * m2[ 9] + m1[11] * m2[13];
    result[10] = m1[ 8] * m2[ 2] + m1[ 9] * m2[ 6] + m1[10] * m2[10] + m1[11] * m2[14];
    result[11] = m1[ 8] * m2[ 3] + m1[ 9] * m2[ 7] + m1[10] * m2[11] + m1[11] * m2[15];

    result[12] = m1[12] * m2[ 0] + m1[13] * m2[ 4] + m1[14] * m2[ 8] + m1[15] * m2[12];
    result[13] = m1[12] * m2[ 1] + m1[13] * m2[ 5] + m1[14] * m2[ 9] + m1[15] * m2[13];
    result[14] = m1[12] * m2[ 2] + m1[13] * m2[ 6] + m1[14] * m2[10] + m1[15] * m2[14];
    result[15] = m1[12] * m2[ 3] + m1[13] * m2[ 7] + m1[14] * m2[11] + m1[15] * m2[15];
	
	memcpy(m1,result,4*16);
}

//multiplies two matrix4x4s together. M1*M2 -> overwrites m2
void MultMatrixPre(const float * m1,float * m2)
{
	float result[16];
    result[ 0] = m1[ 0] * m2[ 0] + m1[ 1] * m2[ 4] + m1[ 2] * m2[ 8] + m1[ 3] * m2[12];
    result[ 1] = m1[ 0] * m2[ 1] + m1[ 1] * m2[ 5] + m1[ 2] * m2[ 9] + m1[ 3] * m2[13];
    result[ 2] = m1[ 0] * m2[ 2] + m1[ 1] * m2[ 6] + m1[ 2] * m2[10] + m1[ 3] * m2[14];
    result[ 3] = m1[ 0] * m2[ 3] + m1[ 1] * m2[ 7] + m1[ 2] * m2[11] + m1[ 3] * m2[15];

    result[ 4] = m1[ 4] * m2[ 0] + m1[ 5] * m2[ 4] + m1[ 6] * m2[ 8] + m1[ 7] * m2[12];
    result[ 5] = m1[ 4] * m2[ 1] + m1[ 5] * m2[ 5] + m1[ 6] * m2[ 9] + m1[ 7] * m2[13];
    result[ 6] = m1[ 4] * m2[ 2] + m1[ 5] * m2[ 6] + m1[ 6] * m2[10] + m1[ 7] * m2[14];
    result[ 7] = m1[ 4] * m2[ 3] + m1[ 5] * m2[ 7] + m1[ 6] * m2[11] + m1[ 7] * m2[15];

    result[ 8] = m1[ 8] * m2[ 0] + m1[ 9] * m2[ 4] + m1[10] * m2[ 8] + m1[11] * m2[12];
    result[ 9] = m1[ 8] * m2[ 1] + m1[ 9] * m2[ 5] + m1[10] * m2[ 9] + m1[11] * m2[13];
    result[10] = m1[ 8] * m2[ 2] + m1[ 9] * m2[ 6] + m1[10] * m2[10] + m1[11] * m2[14];
    result[11] = m1[ 8] * m2[ 3] + m1[ 9] * m2[ 7] + m1[10] * m2[11] + m1[11] * m2[15];

    result[12] = m1[12] * m2[ 0] + m1[13] * m2[ 4] + m1[14] * m2[ 8] + m1[15] * m2[12];
    result[13] = m1[12] * m2[ 1] + m1[13] * m2[ 5] + m1[14] * m2[ 9] + m1[15] * m2[13];
    result[14] = m1[12] * m2[ 2] + m1[13] * m2[ 6] + m1[14] * m2[10] + m1[15] * m2[14];
    result[15] = m1[12] * m2[ 3] + m1[13] * m2[ 7] + m1[14] * m2[11] + m1[15] * m2[15];
	
	memcpy(m2,result,4*16);
}


//multiplies a matrix4x4 by a vector4 m*v = result
void MultMatrixVect(float * m, float * v, float * result)
{
    result[0] = m[ 0] * v[ 0] + m[ 1] * v[ 1] + m[ 2] * v[ 2] + m[ 3] * v[ 3];
    result[1] = m[ 4] * v[ 0] + m[ 5] * v[ 1] + m[ 6] * v[ 2] + m[ 7] * v[ 3];
    result[2] = m[ 8] * v[ 0] + m[ 9] * v[ 1] + m[10] * v[ 2] + m[11] * v[ 3];
    result[3] = m[12] * v[ 0] + m[13] * v[ 1] + m[14] * v[ 2] + m[15] * v[ 3];
}

//multiplies a matrix4x4 by a vector3 m*v = result
void MultMatrixVect3(float * m, float * v, float * result)
{
    result[0] = m[ 0] * v[ 0] + m[ 1] * v[ 1] + m[ 2] * v[ 2] + m[ 3];
    result[1] = m[ 4] * v[ 0] + m[ 5] * v[ 1] + m[ 6] * v[ 2] + m[ 7];
    result[2] = m[ 8] * v[ 0] + m[ 9] * v[ 1] + m[10] * v[ 2] + m[11];
}

//multiplies a matrix4x4 by a vector3 v = m*v 
void MultMatrixVect3(float * m, float * v)
{
	float result[3];
    result[0] = m[ 0] * v[ 0] + m[ 1] * v[ 1] + m[ 2] * v[ 2] + m[ 3];
    result[1] = m[ 4] * v[ 0] + m[ 5] * v[ 1] + m[ 6] * v[ 2] + m[ 7];
	result[2] = m[ 8] * v[ 0] + m[ 9] * v[ 1] + m[10] * v[ 2] + m[11];
	memcpy(v,result,3*4);
}

//sets matrix m to identitiy
void Identity(float * m)
{
    memset(m, 0, sizeof(float)*16);
    m[0] = 1.0;
    m[5] = 1.0;
    m[10] = 1.0;
    m[15] = 1.0;
}


//construct a scale matrix m from x,y,z scale componenets
void ScaleMatrix(float x, float y, float z,float * m)
{
    memset(m, 0, sizeof(float)*16);
    m[0] = x;
    m[5] = y;
    m[10] = z;
    m[15] = 1.0;    
}

//construct a z rotation matrix
void RotationMatrixZ(float degree ,float * m)
{
    memset(m, 0, sizeof(float)*16);
    m[0] = m[5] = (float)cos(degree);
    m[1] = -(float)sin(degree);
    m[4] = -m[1];
    m[10] = m[15] = 1.0;
}

//construct an X rotation matrix
void RotationMatrixX(float degree ,float * m)
{
    memset(m, 0, sizeof(float)*16);
    m[0] = m[15] = 1.0;
    m[5] = m[10] = (float)cos(degree);
    m[9] = (float)sin(degree);
    m[6] = -m[9];    
}

//construct a Y rotation matrix
void RotationMatrixY(float degree, float * m)
{
    memset(m, 0, sizeof(float)*16);
    m[0] = m[10] = (float)cos(degree);
    m[2] = (float)sin(degree);
    m[8] = -m[2];
    m[5] = m[15] = 1.0;
}

//construct an RPY rotation matrix
void RotationMatrixRPY(float r, float p, float y,float*m)
{
    m[0] =  (float)(cos(y) * cos(r) + sin(y)*sin(p)*sin(r));
    m[1] = (float)(-cos(y) * sin(r) + sin(y)*sin(p)*cos(r));
    m[2] = (float)(sin(y) * cos(p));
    m[4] = (float)(cos(p) * sin(r));
    m[5] = (float)(cos(p) * cos(r));
    m[6] = (float)(-sin(p));
    m[8] = (float)(-sin(y) * cos(r) + cos(y) * sin(p) * sin(r));
    m[9] = (float)(sin(y) * sin(r) + cos(y) * sin(p) * cos(r));
    m[10] = (float)(cos(y) * cos(p));
    m[3] = m[7] = m[11] = m[12] = m[13] = m[14] = 0;
    m[15] = 1.0;
}


//transpose a matrix
void Transpose(float *m)
{
    float temp;
    
    temp = m[1];
    m[1] = m[4];
    m[4] = temp;

    temp = m[2];
    m[2] = m[8];
    m[8] = temp;
    
    temp = m[3];
    m[3] = m[12];
    m[12] = temp;
    
    temp = m[6];
    m[6] = m[9];
    m[9] = temp;

    temp = m[7];
    m[7] = m[13];
    m[13] = temp;

    temp = m[11];
    m[11] = m[14];
    m[14] = temp;
}


//create a translation matrix from components
void TranslationMatrix(float x, float y, float z, float * m)
{
    memset(m, 0, sizeof(float)*16);
    m[0] = m[5] = m[10] = m[15] = 1.0;
    m[3] = x;
    m[7] = y;
    m[11] = z;
}


//vector subtraction result = v1 - v2
void VectorSub(float *v1,float *v2,float *result)
{
	result[0] = v1[0] - v2[0];
	result[1] = v1[1] - v2[1];
	result[2] = v1[2] - v2[2];
}

//vector addition result = v1 + v2
void VectorAdd(float *v1,float *v2,float *result)
{
	result[0] = v1[0] + v2[0];
	result[1] = v1[1] + v2[1];
	result[2] = v1[2] + v2[2];
}

//scaler vector multiplication v1 *= s
void VectorScalerMult(float *v1, float s)
{
	v1[0] *= s;
	v1[1] *= s;
	v1[2] *= s;

}

//create a T*RZ*RY*RX matrix
void RotateXYZTranslate(float x, float y, float z, float tx, float ty, float tz, float * m)
{

	float scratch[16];
	Identity(m);
	TranslationMatrix(tx,ty,tz,scratch);
	MultMatrixPost(m,scratch);
	RotationMatrixZ(z,scratch);
	MultMatrixPost(m,scratch);
	RotationMatrixY(y,scratch);
	MultMatrixPost(m,scratch);
	RotationMatrixX(x,scratch);
	MultMatrixPost(m,scratch);

}

void RotateXYZTranslateInv(float x, float y, float z, float tx, float ty, float tz, float * m)
{
	float scratch[16];
	Identity(m);

	RotationMatrixX(x,scratch);
	Transpose(scratch);
	MultMatrixPost(m,scratch);
	RotationMatrixY(y,scratch);
	Transpose(scratch);
	MultMatrixPost(m,scratch);
	RotationMatrixZ(z,scratch);
	Transpose(scratch);
	MultMatrixPost(m,scratch);

	TranslationMatrix(-tx,-ty,-tz,scratch);
	MultMatrixPost(m,scratch);

}


//create a RX*RY*RZ*T matrix
void TranslateRotateZYX(float x, float y, float z, float tx, float ty, float tz, float * m)
{
	
	float rot1[16];
	float rot2[16];
	float rot3[16];
	RotationMatrixX(x,rot1);
	RotationMatrixY(y,rot2);
	RotationMatrixZ(z,rot3);
	float trans[16];
	TranslationMatrix(tx,ty,tz,trans);

	float scratch[16];
	MultMatrix(rot1,rot2,m);
	MultMatrix(m,rot3,scratch);
	MultMatrix(scratch,trans,m);

}


//get the magnitude of a vector
float VectorMag(float * v)
{
	return (float)sqrt(v[0]*v[0]+v[1]*v[1]+v[2]*v[2]);
}

//calculate teh dot product of v1 and v2 (only use 3 elements)
float Vector3Dot(float *v1, float * v2)
{
	return v1[0]*v2[0]+v1[1]*v2[1]+v1[2]*v2[2];
}

//calculate teh dot product of v1 and v2 (use  all 4 elements)
float Vector4Dot(float *v1, float * v2)
{
	return v1[0]*v2[0]+v1[1]*v2[1]+v1[2]*v2[2]+v1[3]*v2[3];
}


//normalize a vector
void NormalizeVector(float * v)
{
	float m = VectorMag(v);
	if (m == 0.0)
		return;
	v[0] /= m;
	v[1] /= m;
	v[2] /= m;
	v[3] = 1.0;
}

void InverseRotate(float * m, float * v)
{
	float r[3];
	r[0] = m[0] * v[0] + m[1] * v[1] + m[2] * v[2];
	r[1] = m[4] * v[0] + m[5] * v[1] + m[6] * v[2];
	r[2] = m[8] * v[0] + m[9] * v[1] + m[10] * v[2];
	memcpy(v,r,4*3);
}

void InverseTranslate(float * m, float * v)
{
	v[0] = v[0] - m[3];
	v[1] = v[1] - m[7];
	v[2] = v[2] - m[11];
}